/*
 * 上传配置项
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using MySystem.Models.Bs;
using Library;
using LitJson;

namespace MySystem.Service.Bs
{
    public class UploadParamsService
    {
        string _conn = "";
        public UploadParamsService()
        {
            _conn = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        /// <summary>
        /// 查询列表
        /// </summary>
        /// <param name="relationData">关联表</param>
        /// <param name="condition">查询条件(sql语句)</param>
        /// <param name="count">总数（输出）</param>
        /// <param name="page">页码</param>
        /// <param name="limit">每页条数</param>
        /// <returns></returns>
        public List<Dictionary<string, object>> List(List<RelationData> relationData, string condition, out int count, int page = 1, int limit = 30, string orderBy = "Sort desc,Id desc")
        {
            List<string> fields = new List<string>(); //要显示的列
            fields.Add("Id");
            fields.Add("CreateDate"); //添加时间
            fields.Add("Status"); //状态
            fields.Add("TableName"); //表名
fields.Add("ColumnName"); //字段名
fields.Add("ColumnEnName"); //字段英文明
fields.Add("ParamString"); //参数
fields.Add("TableEnName"); //表英文名

            Dictionary<string, object> obj = new DbService(AppConfig.Base.dbTables, _conn).IndexData("UploadParams", relationData, orderBy, page, limit, condition, fields);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            count = int.Parse(obj["count"].ToString());
            return diclist;
        }
        public List<Dictionary<string, object>> List(List<RelationData> relationData, string condition, int page = 1, int limit = 30, string orderBy = "Sort desc,Id desc")
        {
            List<string> fields = new List<string>(); //要显示的列
            fields.Add("Id");
            fields.Add("CreateDate"); //添加时间
            fields.Add("Status"); //状态
            fields.Add("TableName"); //表名
fields.Add("ColumnName"); //字段名
fields.Add("ColumnEnName"); //字段英文明
fields.Add("ParamString"); //参数
fields.Add("TableEnName"); //表英文名

            Dictionary<string, object> obj = new DbService(AppConfig.Base.dbTables, _conn).IndexData("UploadParams", relationData, orderBy, page, limit, condition, fields);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            return diclist;
        }

        /// <summary>
        /// 查询一条记录
        /// </summary>
        /// <param name="Id">主键Id</param>
        /// <returns></returns>
        public UploadParams Query(int Id)
        {
            WebCMSEntities db = new WebCMSEntities();
            UploadParams editData = db.UploadParams.FirstOrDefault(m => m.Id == Id) ?? new UploadParams();
            db.Dispose();
            return editData;
        }

        /// <summary>
        /// 查询记录数
        /// </summary>
        /// <param name="Id">主键Id</param>
        /// <returns></returns>
        public int Count(string condition = "")
        {
            int result = 0;
            DataTable dt = CustomerSqlConn.dtable("select count(Id) from UploadParams where 1=1" + condition, _conn);
            if(dt.Rows.Count > 0)
            {
                result = int.Parse(function.CheckInt(dt.Rows[0][0].ToString()));
            }
            return result;
        }

        /// <summary>
        /// 查询是否存在
        /// </summary>
        /// <param name="Id">主键Id</param>
        /// <returns></returns>
        public bool Exist(int Id)
        {
            WebCMSEntities db = new WebCMSEntities();
            bool check = db.UploadParams.Any(m => m.Id == Id);
            db.Dispose();
            return check;
        }

        /// <summary>
        /// 添加数据
        /// </summary>
        /// <param name="Fields">要设置的字段</param>
        /// <returns></returns>
        public AppResultJson Add(Dictionary<string, object> fields, bool check = true)
        {
            if(check)
            {
                
            }
            int Id = new DbService(AppConfig.Base.dbTables, _conn).Add("UploadParams", fields, 0);
            return new AppResultJson(){ Status = "1", Data = Id };
        }

        /// <summary>
        /// 修改数据
        /// </summary>
        /// <param name="Fields">要设置的字段</param>
        /// <param name="Id">主键Id</param>
        public AppResultJson Edit(Dictionary<string, object> fields, int Id, bool check = true)
        {
            if(check)
            {
                
            }
            new DbService(AppConfig.Base.dbTables, _conn).Edit("UploadParams", fields, Id);
            return new AppResultJson(){ Status = "1", Data = Id };
        }

        /// <summary>
        /// 逻辑删除
        /// </summary>
        /// <param name="Id">主键Id</param>
        public void Remove(int Id)
        {
            Dictionary<string, object> fields = new Dictionary<string, object>();
            fields.Add("Status", -1);
            new DbService(AppConfig.Base.dbTables, _conn).Edit("UploadParams", fields, Id);
        }

        /// <summary>
        /// 删除数据
        /// </summary>
        /// <param name="Id">主键Id</param>
        public void Delete(int Id)
        {
            new DbService(AppConfig.Base.dbTables, _conn).Delete("UploadParams", Id);
        }

        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id">主键Id</param>
        /// <param name="Sort">排序序号</param>
        public void Sort(int Id, int Sort)
        {
            new DbService(AppConfig.Base.dbTables, _conn).Sort("UploadParams", Sort, Id);
        }

        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData">json数据</param>
        public void Import(string ExcelData)
        {
            WebCMSEntities db = new WebCMSEntities();
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.UploadParams.Add(new UploadParams()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            db.Dispose();
        }

        /// <summary>
        /// 导出excel表格
        /// </summary>
        /// <param name="fields">查询条件(单个字段)</param>
        /// <param name="condition">查询条件(sql语句)</param>
        /// <returns></returns>
        // public void ExportExcel(List<RelationData> relationData, string condition)
        // {
            
        // }
    }
}